/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest{}

// AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest struct for AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest
type AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest struct {
	CallbackUrl *string                            `json:"callbackUrl,omitempty"`
	Config      *GoogleBigQueryCustomDtoAuthorizer `json:"config,omitempty"`
}

// NewAppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest instantiates a new AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest() *AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest {
	this := AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest{}
	var callbackUrl string = "https://my.app.com/callback?code=aaaaBBBBccc1234"
	this.CallbackUrl = &callbackUrl
	return &this
}

// NewAppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequestWithDefaults instantiates a new AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequestWithDefaults() *AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest {
	this := AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest{}
	var callbackUrl string = "https://my.app.com/callback?code=aaaaBBBBccc1234"
	this.CallbackUrl = &callbackUrl
	return &this
}

// GetCallbackUrl returns the CallbackUrl field value if set, zero value otherwise.
func (o *AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest) GetCallbackUrl() string {
	if o == nil || IsNil(o.CallbackUrl) {
		var ret string
		return ret
	}
	return *o.CallbackUrl
}

// GetCallbackUrlOk returns a tuple with the CallbackUrl field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest) GetCallbackUrlOk() (*string, bool) {
	if o == nil || IsNil(o.CallbackUrl) {
		return nil, false
	}
	return o.CallbackUrl, true
}

// HasCallbackUrl returns a boolean if a field has been set.
func (o *AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest) HasCallbackUrl() bool {
	if o != nil && !IsNil(o.CallbackUrl) {
		return true
	}

	return false
}

// SetCallbackUrl gets a reference to the given string and assigns it to the CallbackUrl field.
func (o *AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest) SetCallbackUrl(v string) {
	o.CallbackUrl = &v
}

// GetConfig returns the Config field value if set, zero value otherwise.
func (o *AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest) GetConfig() GoogleBigQueryCustomDtoAuthorizer {
	if o == nil || IsNil(o.Config) {
		var ret GoogleBigQueryCustomDtoAuthorizer
		return ret
	}
	return *o.Config
}

// GetConfigOk returns a tuple with the Config field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest) GetConfigOk() (*GoogleBigQueryCustomDtoAuthorizer, bool) {
	if o == nil || IsNil(o.Config) {
		return nil, false
	}
	return o.Config, true
}

// HasConfig returns a boolean if a field has been set.
func (o *AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest) HasConfig() bool {
	if o != nil && !IsNil(o.Config) {
		return true
	}

	return false
}

// SetConfig gets a reference to the given GoogleBigQueryCustomDtoAuthorizer and assigns it to the Config field.
func (o *AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest) SetConfig(v GoogleBigQueryCustomDtoAuthorizer) {
	o.Config = &v
}

func (o AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.CallbackUrl) {
		toSerialize["callbackUrl"] = o.CallbackUrl
	}
	if !IsNil(o.Config) {
		toSerialize["config"] = o.Config
	}
	return toSerialize, nil
}

type NullableAppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest struct {
	value *AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest
	isSet bool
}

func (v NullableAppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest) Get() *AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest {
	return v.value
}

func (v *NullableAppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest) Set(val *AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableAppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableAppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest(val *AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest) *NullableAppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest {
	return &NullableAppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest{value: val, isSet: true}
}

func (v NullableAppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthCallbackRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
